from _Main import _Main

class SecurePage(_Main):

    def awake(self, trans):
        _Main.awake(self, trans)

        session = trans.session()
        request = trans.request()
        app = trans.application()
        loginid = session.value('loginid', None)
        if loginid:
            session.delValue('loginid')
        if request.hasField('logout'):
            session.values().clear()
            request.setField('msg', 'Logout avvenuto.')
            request.setField('action', request.urlPath().split('/')[-1])
            app.forward(trans, 'LoginPage.py')
        elif request.hasField('login') and request.hasField('username') and request.hasField('password'):
            session.values().clear()
            username = request.field('username')
            password = request.field('password')
            if request.field('loginid', 'nologin')==loginid and self.loginUser(username, password):
                request.delField('username')
                request.delField('password')
                request.delField('login')
                request.delField('loginid')
            else:
                request.setField('msg', 'Login fallito!')
                app.forward(trans, 'LoginPage.py')
        elif not self.getLoggedInUser():
            session.values().clear()
            app.forward(trans, 'LoginPage')

    def respond(self, trans):
        if self.getLoggedInUser():
            _Main.respond(self, trans)
  
    def isValidUserAndPassword(self, username, password):
        users = [('Marco', 'Marco'), ('Alessandro', 'Alessandro')]
        return (username, password) in users

    def loginUser(self, username, password):
        if self.isValidUserAndPassword(username, password):
            self.session().setValue('authenticated_user', username)
            return 1
        else:
            self.session().setValue('authenticated_user', None)
            return 0

    # Spostato in "_Main"
    #def getLoggedInUser(self):
    #    return self.session().value('authenticated_user', None)

